<?php
// Own namespace
namespace Org\Mxchange\CoreFramework\Parser;

// Import framework stuff
use Org\Mxchange\CoreFramework\Generic\FrameworkInterface;

/**
 * A Parseable interface
 *
 * @author		Roland Haeder <webmaster@shipsimu.org>
 * @version		0.0.0
 * @copyright	Copyright (c) 2007, 2008 Roland Haeder, 2009 - 2021 Core Developer Team
 * @license		GNU GPL 3.0 or any newer version
 * @link		http://www.shipsimu.org
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */
interface Parseable extends FrameworkInterface {
	// Exception constants
	const EXCEPTION_XML_PARSER_ERROR  = 0x1e0;
	const EXCEPTION_XML_NODE_UNKNOWN  = 0x1e1;
	const EXCEPTION_XML_NODE_MISMATCH = 0x1e2;

	/**
	 * Parses the given XML content
	 *
	 * @param	$content	Valid XML content
	 * @return	void
	 * @throws	XmlParserException	If an XML error was found
	 */
	function parseXmlContent (string $content);

}
